

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable AcqMode 0
    variable AutoReset 0
    variable DataFormat 0
    variable allcounters 0
    variable allmodules 0
    variable Dwell 0x80000000

    variable OperationMode 0
    variable Enables -1
    for {set i 0} {$i < 32} {incr i} {variable Enable$i 1}
    for {set i 0} {$i < 32} {incr i} {variable Counter$i [expr 0x100000000 / (1+$i)]}

    variable Rmsg
    variable Wmsg

    variable ModuleName v830
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures

   proc ReadRegister {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
       } else {
           InsertLog "ReadRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $r.$RegName returned: [lindex $Wmsg 5]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleMenu
        variable allcounters
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             InsertLog "allcounters=$allcounters; allmodules=$allmodules"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }
 
    proc UpdateModule {} {
        variable AcqMode
        variable AutoReset
        variable DataFormat
        variable Dwell

        variable OperationMode
        variable Enables
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Counter$i}

        set Dwell [ReadRegister Dwell]

        set vl [ReadRegister CR]
        set OperationMode $vl
        set AcqMode [expr $vl & 3]
        set AutoReset [expr $vl >> 7 & 1]
        set DataFormat [expr $vl >> 1 & 1]

        for {set i 0} {$i < 32} {incr i} {
            set Counter$i [ReadRegister Counter$i]
        }

        set Enables [ReadRegister Enables]
        for {set i 0} {$i < 32} {incr i 1} {
            set Enable$i [expr ($Enables >> $i) & 1]
        }

   }

    proc do_SetOperationMode {w v} {

        switch $w {
           ACQ0      {set data 0x01}
           ACQ1      {set data 0x02}
           AUTORESET {set data 0x80}
           DATAFMT   {set data 0x04}
        }

        switch $v {
           0   {WriteRegister BitSet $data}
           1   {WriteRegister BitClr $data}
        }
 
    }

     proc do_SetDwell {vl} {WriteRegister Dwell $vl}

     proc do_SetEnable {j vl} {
        variable Enables

        variable allcounters

        for {set i 0} {$i < 32} {incr i} {variable Enable$i}

          for {set i 0} {$i < 32} {incr i 1} {
             if {$allcounters == 0 && $j != $i} {continue}

             set Enable$i $vl
             set enables 0
             for {set k 0} {$k < 32} {incr k 1} {
                   if {[set Enable$k] == 1} {set enables [expr $enables + (1 << $k)]}
             }
             WriteRegister Enables $enables
             set Enables $enables
          }

     }

    proc do_Save {} {
        variable ::VMEConfig::ConfigBase
        variable Base
        variable ModuleIndex
        variable ModuleMenu

        variable OperationMode
        variable Dwell
        variable Enables

        set SaveFile [file join $ConfigBase V830.dat]

        set z [catch {open $SaveFile w} file]
        if {$z != 0} {
            Alert "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
           do_Select $module
           InsertLog "Saving Settings for CAEN V830 modules"

           puts $file "$module OperationMode $OperationMode"
           puts $file "$module Dwell $Dwell"
           puts $file "$module Enables $Enables"

        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V830 modules updated in $SaveFile"
    }

    proc do_Restore {} {
        variable ::VMEConfig::ConfigBase
        variable ModuleIndex
        variable allmodules

        InsertLog "Restoring Settings for CAEN V830 modules"

        set SaveFile [file join $ConfigBase V830.dat]

        set z [catch {open $SaveFile r} file]
        if {$z != 0} {
            Alert "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set allmodules 0

        set SAV $ModuleIndex
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set m [first $item]
            if {$m != $ModuleIndex} {do_Select $m}
            set p [second $item]
            set vl [third $item]
            switch -glob $p {
                OperationMode   {WriteRegister CR $vl}
                Dwell           {WriteRegister Dwell $vl}
                Enables         {WriteRegister Enables $vl}
            }
        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V830 modules restored from $SaveFile"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLCOUNTERS {variable allcounters; set allcounters [expr ($allcounters + 1) & 1]}
                   ALLMODULES  {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {}
                       if {$i == 32} {do_SetDwell [lindex $w 2]}
                   }

                   ENABLE  {UpdateModule; do_SetEnable [lindex $w 1] [lindex $w 2]}

                   ACQMODE    {
                       switch [lindex $w 1] {
                          0   {do_SetOperationMode ACQ0 0; do_SetOperationMode ACQ1 0}
                          1   {do_SetOperationMode ACQ0 1; do_SetOperationMode ACQ1 0}
                          2   {do_SetOperationMode ACQ0 0; do_SetOperationMode ACQ1 1}
                       }
                   }
                   AUTORESET  {do_SetOperationMode AUTORESET [lindex $w 1]}
                   DATAFMT    {do_SetOperationMode DATAFMT [lindex $w 1]}

                   SAVE      {UpdateModule; do_Save}
                   RESTORE   {do_Restore; UpdateModule}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

